//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D2D92F0036A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D2D92F0036A.cm

//## begin module%3D2D92F0036A.cp preserve=no
//## end module%3D2D92F0036A.cp

//## Module: AddTableComponent%3D2D92F0036A; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/AddTableComponent.h

#ifndef ADDTABLECOMPONENT_H
#define ADDTABLECOMPONENT_H 1

//## begin module%3D2D92F0036A.additionalIncludes preserve=no
//## end module%3D2D92F0036A.additionalIncludes

//## begin module%3D2D92F0036A.includes preserve=yes
class UniqueEnergy;
//## end module%3D2D92F0036A.includes

// AddComponent
#include <XSModel/Model/Component/AddComponent.h>

class TableComponent;

//## begin module%3D2D92F0036A.declarations preserve=no
//## end module%3D2D92F0036A.declarations

//## begin module%3D2D92F0036A.additionalDeclarations preserve=yes
//## end module%3D2D92F0036A.additionalDeclarations


//## begin AddTableComponent%36C456CD6038.preface preserve=yes
//## end AddTableComponent%36C456CD6038.preface

//## Class: AddTableComponent%36C456CD6038
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3D2DAC1C02AD;ComponentBase { -> }

class AddTableComponent : public AddComponent  //## Inherits: <unnamed>%36C456F7EC48
{
  //## begin AddTableComponent%36C456CD6038.initialDeclarations preserve=yes
  //## end AddTableComponent%36C456CD6038.initialDeclarations

  public:
    //## Constructors (generated)
      AddTableComponent(const AddTableComponent &right);

    //## Constructors (specified)
      //## Operation: AddTableComponent%37EFA56FCC68;   C++
      AddTableComponent (CGroupBase* p);

    //## Destructor (generated)
      virtual ~AddTableComponent();


    //## Other Operations (specified)
      //## Operation: calculate%3A8BEC940157;            C++
      virtual void calculate (bool saveComponentFlux, bool frozen);

      //## Operation: clone%3AB785AB02C4
      virtual AddTableComponent* clone (CGroupBase* p) const;

      //## Operation: clearArrays%3D7CF33A0163
      virtual void clearArrays (const std::set<UniqueEnergy*>& currentEngs);

      //## Operation: initializeForFit%4593FF0001CE
      virtual void initializeForFit ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: tableFile%3767EF22DE78
      const string& tableFile () const;
      void tableFile (const string& value);

    // Additional Public Declarations
      //## begin AddTableComponent%36C456CD6038.public preserve=yes
      //## end AddTableComponent%36C456CD6038.public

  protected:
    // Additional Protected Declarations
      //## begin AddTableComponent%36C456CD6038.protected preserve=yes
      //## end AddTableComponent%36C456CD6038.protected

  private:

    //## Other Operations (specified)
      //## Operation: swap%3761395EE8D8;    C++
      virtual void swap (Component& right);

      //## Operation: read%374D98CBF3BE;     C++
      virtual int read ();

      //## Operation: copy%3A953E4603B5
      virtual void copy (const Component& right);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: tableType%3767EF8DA2E8
      const string tableType () const;
      void tableType (string value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Model::Component::<unnamed>%3D2D93CC00FD
      //## Role: AddTableComponent::table%3D2D93CC035D
      const TableComponent* table () const;
      void table (TableComponent* value);

    // Additional Private Declarations
      //## begin AddTableComponent%36C456CD6038.private preserve=yes
      //## end AddTableComponent%36C456CD6038.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin AddTableComponent::tableFile%3767EF22DE78.attr preserve=no  public: string {U} ""
      string m_tableFile;
      //## end AddTableComponent::tableFile%3767EF22DE78.attr

      //## begin AddTableComponent::tableType%3767EF8DA2E8.attr preserve=no  private: string {U} ""
      string m_tableType;
      //## end AddTableComponent::tableType%3767EF8DA2E8.attr

    // Data Members for Associations

      //## Association: XSModel::Model::Component::<unnamed>%3D2D93CC00FD
      //## begin AddTableComponent::table%3D2D93CC035D.role preserve=no  private: TableComponent { -> 1RFHgN}
      TableComponent* m_table;
      //## end AddTableComponent::table%3D2D93CC035D.role

    // Additional Implementation Declarations
      //## begin AddTableComponent%36C456CD6038.implementation preserve=yes
      //## end AddTableComponent%36C456CD6038.implementation

};

//## begin AddTableComponent%36C456CD6038.postscript preserve=yes
//## end AddTableComponent%36C456CD6038.postscript

// Class AddTableComponent 

//## Get and Set Operations for Class Attributes (inline)

inline const string& AddTableComponent::tableFile () const
{
  //## begin AddTableComponent::tableFile%3767EF22DE78.get preserve=no
  return m_tableFile;
  //## end AddTableComponent::tableFile%3767EF22DE78.get
}

inline void AddTableComponent::tableFile (const string& value)
{
  //## begin AddTableComponent::tableFile%3767EF22DE78.set preserve=no
  m_tableFile = value;
  //## end AddTableComponent::tableFile%3767EF22DE78.set
}

inline const string AddTableComponent::tableType () const
{
  //## begin AddTableComponent::tableType%3767EF8DA2E8.get preserve=no
  return m_tableType;
  //## end AddTableComponent::tableType%3767EF8DA2E8.get
}

inline void AddTableComponent::tableType (string value)
{
  //## begin AddTableComponent::tableType%3767EF8DA2E8.set preserve=no
  m_tableType = value;
  //## end AddTableComponent::tableType%3767EF8DA2E8.set
}

//## Get and Set Operations for Associations (inline)

inline const TableComponent* AddTableComponent::table () const
{
  //## begin AddTableComponent::table%3D2D93CC035D.get preserve=no
  return m_table;
  //## end AddTableComponent::table%3D2D93CC035D.get
}

inline void AddTableComponent::table (TableComponent* value)
{
  //## begin AddTableComponent::table%3D2D93CC035D.set preserve=no
  m_table = value;
  //## end AddTableComponent::table%3D2D93CC035D.set
}

//## begin module%3D2D92F0036A.epilog preserve=yes
//## end module%3D2D92F0036A.epilog


#endif
